
pipeline {
    agent any
    environment {
        DOCKER_BUILDKIT = "1"
        REPOSITORY = "nodej/demo"
        REGISTRY = "201028276066.dkr.ecr.us-east-1.amazonaws.com"
    }
    stages {

        stage('Build') {
            steps {
                echo 'Building Docker Image'               
            }
        }

        stage('Push') {
            when {
                branch 'master'
            }
            steps {
                script {

                    sh '''
                        eval $(ssh-agent)
                        ssh-add ~/.ssh/gitlab
                        docker build -t $REPOSITORY:$BUILD_NUMBER --ssh default=$SSH_AUTH_SOCK  ./app
                    '''

                    
                }
                script {
                    sh '''
                        alias aws='docker run --rm -i -v ~/.aws:/root/.aws -v $(pwd):/aws amazon/aws-cli'
                        aws ecr get-login-password --region us-east-1 | docker login --username AWS --password-stdin $REGISTRY
                        aws ecr describe-repositories --repository-names $REPOSITORY || aws ecr create-repository --repository-name $REPOSITORY
                        docker tag $REPOSITORY:$BUILD_NUMBER $REGISTRY/$REPOSITORY:$BUILD_NUMBER
                        docker push $REGISTRY/$REPOSITORY:$BUILD_NUMBER
                    '''
                }
            }
        }
    }
}
